
import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.*;
import java.awt.event.*;
import java.io.Serializable;

import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;

public class Board extends JPanel implements ActionListener 
{
    private Timer timer;
    private Hero hero;
    private static NetworkClient nc;
    ArrayList<HeroStats> collection;
    private ArrayList<Rectangle> collisionList = new ArrayList();

    public Board() 
    {

        addKeyListener(new TAdapter());
        setFocusable(true);
        setBackground(Color.WHITE);
        setDoubleBuffered(true);
        hero = new Hero();
        nc = new NetworkClient();

        loadCollisionList();

        timer = new Timer(5, this);
        timer.start();
    }

    public void paint(Graphics g) {
        super.paint(g);
        Graphics2D g2d = (Graphics2D)g;

        /*if (hero.isVisible())
        g2d.drawImage(hero.getImage(), hero.getX(), hero.getY(), this);*/

        collection = nc.getCollection();     
        Player player = null;
        for(HeroStats tmp : collection)
        {
            g2d.drawImage(hero.getImage(tmp), (int)tmp.x, (int)tmp.y, this);
            /*player = new Player(tmp);
            g2d.drawImage(player.getImage(), player.getX(), player.getY(), this);*/
        }

        //obrys
        g.setColor(Color.BLUE);
        g.fillRect(0, 0, 1008, 5);
        g.fillRect(0, 0, 5, 740); 
        g.fillRect(0, 710, 1008, 5);
        g.fillRect(1008, 0, 5, 740); 

        //patra
        g.fillRect(100, 650, 250, 5);
        g.fillRect(200, 590, 400, 5);

        Toolkit.getDefaultToolkit().sync();
        g.dispose();
    }

    public void actionPerformed(ActionEvent e) {
        hero.doKeyAction();
        hero.action();    
        hero.sendStats(nc);

        checkCollisions();
        repaint();  
    }

    public void loadCollisionList()
    {
        collisionList.add(new Rectangle(0, 710, 1008, 5));
        collisionList.add(new Rectangle(100, 650, 250, 5));
        collisionList.add(new Rectangle(200, 590, 400, 5));
        
    }

    public void checkCollisions() 
    {      
        boolean standingSolid = false;
        Rectangle heroRectangle = hero.getBounds();
        for(Rectangle tmp : collisionList)
        {
            if((heroRectangle.getY()+heroRectangle.getHeight()) >= tmp.getY())
            {
                if((heroRectangle.getY()+heroRectangle.getHeight()) - tmp.getY() < 3)
                    if(tmp.intersects(heroRectangle))
                    {
                        standingSolid = true;
                        hero.setIsOnGround(true); 
                        hero.setJump(false); 
                    }
            } 
            if(heroRectangle.getY() >= tmp.getY())
            {
                if((heroRectangle.getY() - tmp.getY()) < 3)
                    if(!(((heroRectangle.getX()+heroRectangle.getWidth()/2) < tmp.getX()) || ((heroRectangle.getX()+heroRectangle.getWidth()/2) > (tmp.getX()+tmp.getWidth()))))
                            hero.setJump(false); 
            }
        }
        if(!standingSolid)
            hero.setIsOnGround(false);   

        /*for(Rectangle tmp : collisionList)
        {
        if((heroRectangle.getY()+heroRectangle.getHeight()) >= tmp.getY())
        {
        System.out.println((heroRectangle.getY()+heroRectangle.getHeight())+"  "+ tmp.getY());
        if(tmp.intersects(heroRectangle))
        {
        standingSolid = true;
        hero.setIsOnGround(true); 
        hero.setJump(false); 
        }
        } 
        }
        if(!standingSolid)
        hero.setIsOnGround(false); 

        /*  Rectangle heroRectangle = hero.getBounds();
         * for(Rectangle tmp : collisionList)
        if (hero.getBounds().intersects(tmp))
        {
        hero.setIsOnGround(true); 
        hero.setJump(false); 
        }*/
    }

    private class TAdapter extends KeyAdapter {
        public void keyReleased(KeyEvent e) 
        {
            hero.keyReleased(e, nc);
        }

        public void keyPressed(KeyEvent e) 
        {
            hero.keyPressed(e, nc);
        }
    }
}

