import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.*;  
import java.io.*; 
import java.nio.*;
import java.util.*;  
import java.lang.*;  
import java.nio.ByteBuffer;
import java.nio.channels.AsynchronousServerSocketChannel;
import java.nio.channels.AsynchronousSocketChannel;
import java.net.InetSocketAddress;
import java.nio.channels.CompletionHandler;
import java.nio.channels.*;

public class Communicator
{   
    private int removeIndexFromList;
    private ArrayList<HeroStats> list = new ArrayList<HeroStats>();
    private Socket socket = null;
    private int numberOfPlayers = -1;
    private ServerSocket ss = null;
    private final Communicator c = this;
    private boolean newClient;
    private HeroStats stat = new HeroStats();
    private HeroStats pokus = new HeroStats();

    private final Communicator communicator = this;

    public Communicator()
    {
        establishConnection();
    }

    public void establishConnection()
    {

        try
        {
            ss = new ServerSocket(4445);
        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.out.println("Server error");
        }
        while(true)
        {
            try
            {
                socket = ss.accept();
                numberOfPlayers++;
                receive();
                send();
                System.out.println("connection Established");
            }
            catch(Exception e)
            {
                e.printStackTrace();
                System.out.println("Connection Error");
            }
        }
    }

    public void receive()
    {

        Thread serverThread = new ServerThread(socket)
            {
                @Override
                @SuppressWarnings("unchecked")
                public void run() 
                {
                    InputStream is = null;
                    OutputStream os = null;
                    ObjectOutputStream oos = null;
                    ObjectInputStream ois = null;

                    String line = null;
                    boolean stop = false;

                    try
                    {
                        s.setTcpNoDelay(true);
                        is = s.getInputStream();
                        ois = new ObjectInputStream(is);
                    }
                    catch(Exception e)
                    {
                        System.out.println(e);
                        stop = true;
                    }

                    while(!stop)
                    {
                        try
                        {
                            stat = (HeroStats)(ois.readObject());
                            //System.out.println("stat.x hned po prijeti? "+stat.x);
                        }
                        catch (IOException e) 
                        {
                            System.out.println(e);
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("IO Error/ Client "+line+" terminated abruptly");
                            stop = true;
                        }
                        catch(NullPointerException e)
                        {
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("Client "+line+" Closed");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                            stop = true;
                        }

                        boolean idFound = false;

                        synchronized(list)
                        {
                            for(int i = 0; i < list.size(); i++)
                            {
                                if(list.get(i).id == stat.id)
                                {
                                    list.set(i, stat);
                                    idFound = true;
                                }
                            }
                            if(!idFound)
                            {
                                //System.out.println("NENI pritomno v listu");
                                list.add(stat);
                            }
                        }

                        /**
                         * Kdyz skonci spojeni, vymaz hrace
                         */
                        if(stop)
                        list.clear();
                        /*if(stop)
                        {
                            Iterator<HeroStats> it = list.iterator();
                            while (it.hasNext()) 
                            {
                                HeroStats h = it.next();
                                if (h.id == stat.id) 
                                {
                                    System.out.println("id "+h.id+" bylo smazano");
                                    it.remove();
                                }
                            }
                        }*/

                    }
                }
            };
        serverThread.start();
    }

    public void send()
    {
        Thread serverThread = new ServerThread(socket)
            {
                @Override
                public void run() 
                {
                    InputStream is = null;
                    OutputStream os = null;
                    ObjectOutputStream oos = null;
                    ObjectInputStream ois = null;

                    Socket s = socket;
                    String line = null;

                    HeroStats stats = null;
                    boolean stop = false;

                    try
                    {
                        os = s.getOutputStream();
                        oos = new ObjectOutputStream(os);
                    }
                    catch(NullPointerException e)
                    {
                        line=this.getName(); //reused String line for getting thread name
                        System.out.println("Client "+line+" Closed");
                        stop = true;
                    }
                    catch(Exception e)
                    {
                        System.out.println(e);
                        stop = true;
                    }

                    while(!stop)
                    {
                        try
                        { 
                            Thread.sleep(10);
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                        }

                        try
                        {
                            synchronized(list)
                            {
                                /*for(HeroStats tmp : list)
                                {
                                System.out.println(s);
                                System.out.println("TADY TI NAPISU id - "+tmp.id);
                                System.out.println("TADY TI NAPISU x - "+tmp.x);
                                System.out.println("TADY TI NAPISU Y - "+tmp.y);
                                }*/

                                oos.writeObject(list);
                                oos.flush();
                                oos.reset();
                            }
                        }
                        catch (IOException e) 
                        {
                            System.out.println(e);
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("IO Error/ Client "+line+" terminated abruptly");
                            stop = true;
                        }
                        catch(NullPointerException e)
                        {
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("Client "+line+" Closed");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                            stop = true;
                        }
                    }
                }
            };
        serverThread.start();
    }

    class ServerThread extends Thread
    {
        Socket s;
        public ServerThread(Socket s)
        {
            this.s = s;
        }

        public void run()
        {

        }

    }

}
