import java.awt.Image;
import javax.swing.ImageIcon;
import java.awt.event.KeyEvent;
import java.awt.Rectangle;
import java.util.HashMap;
import java.util.Map;
import java.io.*;

public class Player
{

    //stringy cest k obrazkum    
    private String hero_crouch_static_left = "hero_crouch_static_left.gif";
    private String hero_crouch_static_right = "hero_crouch_static_right.gif";
    private String hero_crouch_to_stand_left = "hero_crouch_to_stand_left.gif";
    private String hero_crouch_to_stand_right = "hero_crouch_to_stand_right.gif";
    private String hero_crouch_walk_left = "hero_crouch_walk_left.gif";
    private String hero_crouch_walk_right = "hero_crouch_walk_right.gif";
    private String hero_stand_static_left = "hero_stand_static_left.gif";
    private String hero_stand_static_right = "hero_stand_static_right.gif";
    private String hero_stand_to_crouch_left = "hero_stand_to_crouch_left.gif";
    private String hero_stand_to_crouch_right = "hero_stand_to_crouch_right.gif";
    private String hero_walking_left = "hero_walking_left.gif";
    private String hero_walking_right = "hero_walking_right.gif";
    
    //to co kreslim na platno
    private Image image;

    protected int id;
    //samotna pozice na platne
    protected double x;
    protected double y;
    
    //sirka spritu
    private int width;
    private int height;
    protected boolean visible;
    
    /*
     * zmeny provedene stisky klaves
     * problemy pri drzeni obou sipek zaroven,
     * jedna vyrusuje druou pri release checkX = 0
     * Je nutno pouzit dve promenne
     */
    protected int checkXNegative;
    protected int checkXPositive;
    private int checkY;
    
    //fyzika skoku a padu
    private double jumpHeight = 100;
    private double jumpSpeed = 2.0;
    private double jumpAcc = 0.03;
    private double jumpAccTmp = jumpSpeed;
    private double fallSpeed = 2.0;
    private double fallTmp = 0;
    private double fallAcc = 0.03;
    
    
    private ImageIcon ii;
    
    //orientace pandulaka
    protected boolean isOnGround;
    protected boolean jump; 
    protected boolean isStanding;
    protected boolean isLeft;
    protected boolean isRunning;
    
    private HeroStats stats;

    public Player(HeroStats stats)
    {
        this.stats = stats;
        id = stats.id;
        x = stats.x;
        y = stats.y;    
        checkXPositive = stats.checkXPositive;
        checkXNegative = stats.checkXNegative;
        jump = stats.jump;
        isOnGround = stats.isOnGround;
        isStanding = stats.isStanding;
        isLeft = stats.isLeft;
        isRunning = stats.isRunning;
        
        ImageIcon ii = new ImageIcon(this.getClass().getResource(hero_stand_static_right));
        image = ii.getImage();
        width = image.getWidth(null);
        height = image.getHeight(null);
        ////////////////////// !!!!!!!!!!!!!!!! checkni to
        /////////////////////////////////////
        visible = true;
        //////////////////////////////////
        ///////////////////
        setImageIcon();
    }

    /**
     * Snazime se o neco realistejsi a plynulejsi pohyb pohyb:
     * Pri padu jedem od -> 0 - fallSpeed px/cas
     * Pri skoku jedem od -> jumpSpeed - 0 px/cas 
     * 
     * Pri dosazeni maxspeed uz hodnoty neprelezem
     * Na bazi zrychleni, viz. implicitni hodnoty nahore
     */
    
    public void action()
    {       
        //skok
        if(jump)
        {
            jumpAccTmp -= jumpAcc;
            if(jumpAccTmp <= 0.0)
            {
                jump = false;
                jumpAccTmp = jumpSpeed;
            }
            y -= jumpAccTmp;
        }
        
        //volny pad
        if((!isOnGround) && (!jump))
        {
            if(fallTmp <= fallSpeed)
                fallTmp += fallAcc;
            y += fallTmp;
        }
        else
            fallTmp = 0;
        
        //pridavani zmenenych hodnot    
        x += checkXPositive;
        x += checkXNegative;
    }
    
    public int getX() {
        return (int)(x);
    }

    public int getY() {
        return (int)(y);
    }

    public Image getImage() {
        return image;
    }

    public void setVisible(boolean visible) {
        this.visible = visible;
    }
    
    public void setIsOnGround(boolean statement) {
        isOnGround = statement;
    }
    
    public void setJump(boolean statement) {
        jump = statement;
    }

    public boolean isVisible() {
        return visible;
    }
    
    public Rectangle getBounds() {
        return new Rectangle((int)(x), (int)(y), width, height);
    }
    
    public void setImageIcon()
    {
        
        ImageIcon ii = null;
        
        if (isLeft) 
        {
            if( (isStanding) && (!isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_stand_static_left));
            else if( (!isStanding) && (!isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_crouch_static_left));
            else if( (isStanding) && (isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_walking_left));
            else if( (!isStanding) && (isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_crouch_walk_left));
            
            image = ii.getImage();
            width = image.getWidth(null);
            height = image.getHeight(null);
            isLeft = true;
            image.flush();
        }

        if (!isLeft) 
        {
            if( (isStanding) && (!isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_stand_static_right));
            else if( (!isStanding) && (!isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_crouch_static_right));
            else if( (isStanding) && (isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_walking_right));
            else if( (!isStanding) && (isRunning) )
                ii = new ImageIcon(this.getClass().getResource(hero_crouch_walk_right));
            
            image = ii.getImage();
            width = image.getWidth(null);
            height = image.getHeight(null);
            isLeft = true;
            image.flush();
        }
    }
}
